Namespace Geometria

    '**********************************
    '*            PUNTO               *
    '**********************************
    Public Class Punto
        Public Nome As String
        Private mX As Single
        Private mY As Single
        Property X() As Single
            Get
                Return mX
            End Get
            Set(ByVal value As Single)
                mX = value
            End Set
        End Property
        Property Y() As Single
            Get
                Return mY
            End Get
            Set(ByVal value As Single)
                mY = value
            End Set
        End Property
        Public Sub New()
            X = 0
            Y = 0
            Nome = ""
        End Sub
        Public Sub New(ByVal X As Double, ByVal Y As Double, Optional ByVal Nome As String = "")
            Me.X = X
            Me.Y = Y
            Me.Nome = Nome
        End Sub
        Public Sub Cambia(ByVal X As Double, ByVal Y As Double)
            Me.X = X
            Me.Y = Y
        End Sub
        Shared Function Distanza(ByVal P1 As Punto, ByVal P2 As Punto) As Double
            Return ((P1.X - P2.X) ^ 2 + (P1.Y - P2.Y) ^ 2) ^ (0.5)
        End Function
        Shared Function Distanza(ByVal P1 As Punto) As Double
            Dim P As New Punto(0, 0)
            Return Punto.Distanza(P1, P)
        End Function
        Public Sub Disegna(ByVal Piano As Graphics, Optional ByVal Penna As Pen = Nothing)
            If IsNothing(Penna) Then
                Penna = New Pen(Color.Black)
            End If
            Piano.DrawEllipse(Penna, X, Y, 1, 1)
        End Sub
    End Class

    '**********************************
    '*            SEGMENTO            *
    '**********************************
    Public Class Segmento
        Public Nome As String
        Public P1 As Punto
        Public P2 As Punto
        Public Sub New(ByVal P1 As Punto, ByVal P2 As Punto)
            Me.P1 = P1
            Me.P2 = P2
        End Sub
        Public Sub New(ByVal X1 As Double, ByVal Y1 As Double, ByVal X2 As Double, ByVal Y2 As Double)
            P1 = New Punto(X1, Y1)
            P2 = New Punto(X2, Y2)
        End Sub
        Public Function Lunghezza() As Double
            Return Punto.Distanza(P1, P2)
        End Function
        Public Function GeneraNome() As String
            Nome = P1.Nome & P2.Nome
            Return Nome
        End Function
        Public Sub Disegna(ByVal Piano As Graphics, Optional ByVal Penna As Pen = Nothing)
            If IsNothing(Penna) Then
                Penna = New Pen(Color.Black)
            End If
            Piano.DrawLine(Penna, CType(P1.X, Single), CType(P1.Y, Single), CType(P2.X, Single), CType(P2.Y, Single))
        End Sub
        Public Shared Sub DisegnaSegmento(ByVal P1 As Punto, ByVal P2 As Punto, ByVal Piano As Graphics, Optional ByVal Penna As Pen = Nothing)
            If IsNothing(Penna) Then
                Penna = New Pen(Color.Black)
            End If
            Piano.DrawLine(Penna, CType(P1.X, Single), CType(P1.Y, Single), CType(P2.X, Single), CType(P2.Y, Single))
        End Sub
        Public Shared Sub DisegnaSegmento(ByVal X1 As Single, ByVal Y1 As Single, ByVal X2 As Single, ByVal Y2 As Single, ByVal Piano As Graphics, Optional ByVal Penna As Pen = Nothing)
            If IsNothing(Penna) Then
                Penna = New Pen(Color.Black)
            End If
            Piano.DrawLine(Penna, X1, Y1, X2, Y2)
        End Sub

    End Class

    '**********************************
    '*            CERCHIO            *
    '**********************************
    Public Class Cerchio
        Public Nome As String
        Public Centro As Punto
        Public Raggio As Single
        Public Sub New()
            Centro = New Punto(0, 0)
            Raggio = 0
        End Sub
        Public Sub New(ByVal X As Single, ByVal Y As Single, ByVal Raggio As Single)
            Centro = New Punto(X, Y)
            Me.Raggio = Raggio
        End Sub
        Public Sub Disegna(ByVal Piano As Graphics, Optional ByVal Penna As Pen = Nothing)
            If IsNothing(Penna) Then
                Penna = New Pen(Color.Black)
            End If
            Piano.DrawEllipse(Penna, Centro.X - Raggio, Centro.Y - Raggio, Raggio * 2, Raggio * 2)
        End Sub
        Public Overridable Function Area() As Single
            Area = (Raggio ^ 2) * Math.PI
        End Function
        Public Sub Ingrandisci(ByVal Percentuale As Single)
            Raggio += Raggio * Percentuale / 100
        End Sub
    End Class
    Public Class punto2
        Inherits Punto
        Public Sub New(ByVal X As Double, ByVal Y As Double, Optional ByVal Nome As String = "")
            MyBase.New(X, Y, Nome)
        End Sub
        Public Sub New()
        End Sub
    End Class
End Namespace
